//+------------------------------------------------------------------+
//|                                               9Squared Pivot.mq4 |
//|                                   Copyright  2007 Steve Bowley  |
//|                                        http://www.9squaredfx.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Steve Bowley "
#property link      "http://www.9squaredfx.com"

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("S1");
   ObjectDelete("S2");
   ObjectDelete("S3");
   ObjectDelete("R1");
   ObjectDelete("R2");
   ObjectDelete("R3");
   ObjectDelete("Sup1");
   ObjectDelete("Sup2");
   ObjectDelete("Sup3");
   ObjectDelete("Res1");
   ObjectDelete("Res2");
   ObjectDelete("Res3");
   Comment(" ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
//----
double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
ArrayCopyRates(rates, Symbol(), PERIOD_D1);

if(DayOfWeek() == 1)
{
   if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
   {
       yesterday_close = rates[1][4];
       yesterday_high = rates[1][3];
       yesterday_low = rates[1][2];
   }
   else
   {
      for(int d = 5;d>=0;d--)
      {
         if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
         {
             yesterday_close = rates[d][4];
             yesterday_high = rates[d][3];
             yesterday_low = rates[d][2];
         }
         
      }  
   }
}
else
{
    yesterday_close = rates[1][4];
    yesterday_high = rates[1][3];
    yesterday_low = rates[1][2];
}


//---- Calculate Pivots

Comment("\nYesterday quotations:\nH ",yesterday_high,"\nL ",yesterday_low, "\nC ",yesterday_close);
double R = yesterday_high - yesterday_low;//range
double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
double r6 = p + (R * 3.770);
double r5 = p + (R * 2.330);
double r4 = p + (R * 1.500);
double r3 = p + (R * 1.000);
double r2 = p + (R * 0.618);
double r1 = p + (R * 0.382);
double s1 = p - (R * 0.382);
double s2 = p - (R * 0.618);
double s3 = p - (R * 1.000);
double s4 = p - (R * 1.500);
double s5 = p - (R * 2.330);
double s6 = p - (R * 3.770);

drawLine(r6,"R6", Black,2);
drawLabel("Res6",r6,Black);
drawLine(r5,"R5", Maroon,2);
drawLabel("Res5",r5,Maroon);
drawLine(r4,"R4", Red,2);
drawLabel("Res4",r4,Red);
drawLine(r3,"R3", Red,2);
drawLabel("Res3",r3,Red);
drawLine(r2,"R2", Red,2);
drawLabel("Res2",r2,Red);
drawLine(r1,"R1", Red,2);
drawLabel("Res1",r1,Red);

drawLine(p,"PIVOT",Blue,2);
drawLabel("Pivot Level",p,Blue);

drawLine(s1,"S1",Green,2);
drawLabel("Sup1",s1,Green);
drawLine(s2,"S2",Green,2);
drawLabel("Sup2",s2,Green);
drawLine(s3,"S3",Green,2);
drawLabel("Sup3",s3,Green);
drawLine(s4,"S4",Green,2);
drawLabel("Sup4",s4,Green);
drawLine(s5,"S5", DarkGreen,2);
drawLabel("Sup5",s5,DarkGreen);
drawLine(s6,"S6", Black,2);
drawLabel("Sup6",s6,Black);

//----
   return(0);
  }
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[0], lvl);
        ObjectSetText(name, name, 10, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);

    }
    else
    {
        ObjectMove(name, 0, Time[0], lvl);
    }
}


void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);

         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
          
         }
}