
// +----------------------------------------------------------------------------------------+ //
// |                                        XARD FIBO 382  \/                              | //
// |                            Knowledge of the ancients ( )                             | //
// |_________________________________________________o0o___(_)___o0o________________________| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                XARD777 | //
// |----------------------------------------------------------------------------------------| //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 226 (current version)                              | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window
extern bool   soundAlerts = true;
extern bool   emailAlerts = false;

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init()
{
   return(0);
}

// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit()
{

   ObjectDelete("l3");
   ObjectDelete("fibo");
   ObjectDelete("fibo2");
   
   return(0);
}

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

int start()
{
   if(Open[0] == Close[0] &&
      Open[0] == High[0] &&
      Open[0] == Low[0] &&
      GlobalVariableCheck("fiboalert"))
      GlobalVariableDel("fiboalert");
   
   //Find lowest low and highest high
   int il = iLowest(Symbol(), 0, MODE_LOW, 50, 0);
   int ih = iHighest(Symbol(), 0, MODE_HIGH, 50, 0);
   int later = MathMax(il, ih);
   double l = Low[il];
   double h = High[ih];
   
   //Plot 100
   double l382;
   if(il < ih)
      l382 = (h-l)*1.0 + l;
   else
      l382 = h-(h-l)*1.0;

   if(ObjectType("l3") != OBJ_TREND) ObjectDelete("l3");
   if(ObjectGet("l3", OBJPROP_PRICE1) != l382) ObjectDelete("l3");
   ObjectCreate("l3", OBJ_TREND, 0, Time[later], l382, Time[0], l382); 
   ObjectSet("l3", OBJPROP_COLOR, White);
   ObjectSet("l3", OBJPROP_BACK, 1);
   ObjectSet("l3", OBJPROP_STYLE, STYLE_DASH);

   //Write label: Fibonacci 100.0 is at :   
   if(ObjectType("fibo") != OBJ_LABEL) ObjectDelete("fibo");
   if(ObjectFind("fibo") == -1) ObjectCreate("fibo", OBJ_LABEL, 0, Time[5], Close[5]);
   ObjectSetText("fibo", "Fibonacci Level",12,"Arial Bold");
   ObjectSet("fibo", OBJPROP_CORNER, 3);
   //ObjectSet("fibo", OBJPROP_FONTSIZE, 12);
   ObjectSet("fibo", OBJPROP_COLOR, SlateGray);
   ObjectSet("fibo", OBJPROP_XDISTANCE, 11);
   ObjectSet("fibo", OBJPROP_YDISTANCE, 200);
   
   if(ObjectType("fibo2") != OBJ_LABEL) ObjectDelete("fibo2");
   if(ObjectFind("fibo2") == -1) ObjectCreate("fibo2", OBJ_LABEL, 0, Time[5], Close[5]);
   ObjectSetText("fibo2", "38.2 @ " + DoubleToStr(l382,4));
   ObjectSet("fibo2", OBJPROP_CORNER, 3);
   ObjectSet("fibo2", OBJPROP_FONTSIZE, 13);
   ObjectSet("fibo2", OBJPROP_COLOR, Silver);
   ObjectSet("fibo2", OBJPROP_XDISTANCE, 14);
   ObjectSet("fibo2", OBJPROP_YDISTANCE, 185);
   
   //Alert if price is close
   double ATR = iATR(Symbol(), 0, 50, 1);
   if(MathAbs(Close[0] - l382) < ATR)
   {
      if(!GlobalVariableCheck("fiboalert"))
      {
         //Alert code here
         if(soundAlerts)
            Alert("Price is near Fibonacci Retracement at " + l382 + ", " + Symbol() + "! Get ready for trade.");
      
         if(emailAlerts)
            SendMail("Price is near Fibonacci Retracement at " + l382, "Price is near Fibonacci Retracement at " + l382 + ", " + Symbol() + "! Get ready for trade.");
         
         GlobalVariableSet("fiboalert", 1);
      }
   }
   
   return(0);
}
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*
                                                            
                                                          
                              ud$$$**$$$$$$$bc.                          
                          u@**"        4$$$$$$$Nu                       
                        J                ""#$$$$$$r                     
                       @                       $$$$b                    
                     .F                        ^*3$$$                   
                    :% 4                         J$$$N                  
                    $  :F                       :$$$$$                  
                   4F  9                       J$$$$$$$                 
                   4$   k             4$$$$bed$$$$$$$$$                 
                   $$r  'F            $$$$$$$$$$$$$$$$$r                
                   $$$   b.           $$$$$$$$$$$$$$$$$N                
                   $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
    .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
    :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
   @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
   $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
   $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
    ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
       ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
            ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
              ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                   #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                     "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                       "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                         ?k         ?$$$$$$$$$$$F'*                     
                          9$$bL     z$$$$$$$$$$$F                       
                           $$$$    $$$$$$$$$$$$$                        
                            '#$$c  '$$$$$$$$$"                          
                             .@"#$$$$$$$$$$$$b                          
                           z*      $$$$$$$$$$$$N.                       
                         e"      z$$"  #$$$k  '*$$.                     
                     .u*      u@$P"      '#$$c   "$$c                   
              u@$*"""       d$$"            "$$$u  ^*$$b.               
            :$F           J$P"                ^$$$c   '"$$$$$$bL        
           d$$  ..      @$#                      #$$b         '#$       
           9$$$$$$b   4$$                          ^$$k         '$      
            "$$6""$b u$$                             '$    d$$$$$P      
              '$F $$$$$"                              ^b  ^$$$$b$       
               '$W$$$$"                                'b@$$$$"         
                                                        ^$$$*  
*/            